/* menubar.c generated by valac 0.56.8, the Vala compiler
 * generated from menubar.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libindicator/indicator.h"
#include "libindicator/indicator-desktop-shortcuts.h"
#include "libindicator/indicator-image-helper.h"
#include "libindicator/indicator-object.h"
#include "libindicator/indicator-service.h"
#include "libindicator/indicator-service-manager.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <atk/atk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <gio/gio.h>
#include "config.h"
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include "libindicator/indicator-ng.h"
#include <stdio.h>
#include <gtk/gtkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <sys/utsname.h>

#define MENU_BAR_HEIGHT 24
#define UG_SETTINGS_KEY_ONSCREEN_KEYBOARD "onscreen-keyboard"
#define UG_SETTINGS_KEY_HIGH_CONTRAST "high-contrast"
#define UG_SETTINGS_KEY_SCREEN_READER "screen-reader"
#define UG_SETTINGS_KEY_INDICATORS "indicators"
#define UG_SETTINGS_KEY_SHOW_HOSTNAME "show-hostname"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_INDICATOR_MENU_ITEM (indicator_menu_item_get_type ())
#define INDICATOR_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR_MENU_ITEM, IndicatorMenuItem))
#define INDICATOR_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR_MENU_ITEM, IndicatorMenuItemClass))
#define IS_INDICATOR_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR_MENU_ITEM))
#define IS_INDICATOR_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR_MENU_ITEM))
#define INDICATOR_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR_MENU_ITEM, IndicatorMenuItemClass))

typedef struct _IndicatorMenuItem IndicatorMenuItem;
typedef struct _IndicatorMenuItemClass IndicatorMenuItemClass;
typedef struct _IndicatorMenuItemPrivate IndicatorMenuItemPrivate;
enum  {
	INDICATOR_MENU_ITEM_0_PROPERTY,
	INDICATOR_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* indicator_menu_item_properties[INDICATOR_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MENU_BAR (menu_bar_get_type ())
#define MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU_BAR, MenuBar))
#define MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU_BAR, MenuBarClass))
#define IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU_BAR))
#define IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU_BAR))
#define MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU_BAR, MenuBarClass))

typedef struct _MenuBar MenuBar;
typedef struct _MenuBarClass MenuBarClass;
typedef struct _MenuBarPrivate MenuBarPrivate;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;
enum  {
	MENU_BAR_0_PROPERTY,
	MENU_BAR_BACKGROUND_PROPERTY,
	MENU_BAR_HIGH_CONTRAST_PROPERTY,
	MENU_BAR_KEYBOARD_WINDOW_PROPERTY,
	MENU_BAR_ACCEL_GROUP_PROPERTY,
	MENU_BAR_NUM_PROPERTIES
};
static GParamSpec* menu_bar_properties[MENU_BAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	BACKGROUND_DRAW_FLAGS_NONE,
	BACKGROUND_DRAW_FLAGS_GRID
} BackgroundDrawFlags;

#define BACKGROUND_TYPE_DRAW_FLAGS (background_draw_flags_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

#define TYPE_UNITY_GREETER (unity_greeter_get_type ())
#define UNITY_GREETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNITY_GREETER, UnityGreeter))
#define UNITY_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNITY_GREETER, UnityGreeterClass))
#define IS_UNITY_GREETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNITY_GREETER))
#define IS_UNITY_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNITY_GREETER))
#define UNITY_GREETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNITY_GREETER, UnityGreeterClass))

typedef struct _UnityGreeter UnityGreeter;
typedef struct _UnityGreeterClass UnityGreeterClass;
typedef struct _UnityGreeterPrivate UnityGreeterPrivate;

struct _IndicatorMenuItem {
	GtkMenuItem parent_instance;
	IndicatorMenuItemPrivate * priv;
	IndicatorObjectEntry* entry;
};

struct _IndicatorMenuItemClass {
	GtkMenuItemClass parent_class;
};

struct _IndicatorMenuItemPrivate {
	GtkBox* hbox;
};

struct _MenuBar {
	GtkMenuBar parent_instance;
	MenuBarPrivate * priv;
};

struct _MenuBarClass {
	GtkMenuBarClass parent_class;
};

struct _MenuBarPrivate {
	Background* _background;
	gboolean _high_contrast;
	GtkWindow* _keyboard_window;
	GtkAccelGroup* _accel_group;
	gchar* default_theme_name;
	GList* indicator_objects;
	GtkCheckMenuItem* high_contrast_item;
	GPid keyboard_pid;
	GPid reader_pid;
	GtkCheckMenuItem* onscreen_keyboard_item;
};

struct _UnityGreeter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UnityGreeterPrivate * priv;
	gboolean test_mode;
	gboolean orca_needs_kick;
};

struct _UnityGreeterClass {
	GTypeClass parent_class;
	void (*finalize) (UnityGreeter *self);
};

static gint IndicatorMenuItem_private_offset;
static gpointer indicator_menu_item_parent_class = NULL;
static gint MenuBar_private_offset;
static gpointer menu_bar_parent_class = NULL;
VALA_EXTERN UnityGreeter* unity_greeter_singleton;

VALA_EXTERN GType indicator_menu_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorMenuItem, g_object_unref)
VALA_EXTERN IndicatorMenuItem* indicator_menu_item_new (IndicatorObjectEntry* entry);
VALA_EXTERN IndicatorMenuItem* indicator_menu_item_construct (GType object_type,
                                                  IndicatorObjectEntry* entry);
VALA_EXTERN void indicator_menu_item_visibility_changed_cb (IndicatorMenuItem* self,
                                                GtkWidget* widget);
static void _indicator_menu_item_visibility_changed_cb_gtk_widget_show (GtkWidget* _sender,
                                                                 gpointer self);
static void _indicator_menu_item_visibility_changed_cb_gtk_widget_hide (GtkWidget* _sender,
                                                                 gpointer self);
VALA_EXTERN gboolean indicator_menu_item_has_visible_child (IndicatorMenuItem* self);
static void indicator_menu_item_finalize (GObject * obj);
static GType indicator_menu_item_get_type_once (void);
VALA_EXTERN GType menu_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MenuBar, g_object_unref)
VALA_EXTERN GType background_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Background, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN MenuBar* menu_bar_new (Background* bg,
                       GtkAccelGroup* ag);
VALA_EXTERN MenuBar* menu_bar_construct (GType object_type,
                             Background* bg,
                             GtkAccelGroup* ag);
static gboolean menu_bar_real_draw (GtkWidget* base,
                             cairo_t* c);
VALA_EXTERN Background* menu_bar_get_background (MenuBar* self);
VALA_EXTERN GType background_draw_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void background_draw_full (Background* self,
                           cairo_t* c,
                           BackgroundDrawFlags flags);
VALA_EXTERN void menu_bar_set_keyboard_state (MenuBar* self);
VALA_EXTERN gboolean ug_settings_get_boolean (const gchar* key);
static void menu_bar_close_pid (MenuBar* self,
                         GPid* pid);
VALA_EXTERN void menu_bar_cleanup (MenuBar* self);
static void menu_bar_real_get_preferred_height (GtkWidget* base,
                                         gint* min,
                                         gint* nat);
static void menu_bar_greeter_set_env (MenuBar* self,
                               const gchar* key,
                               const gchar* val);
static GtkWidget* menu_bar_make_a11y_indicator (MenuBar* self);
static void menu_bar_keyboard_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item);
static void _menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self);
static void menu_bar_high_contrast_toggled_cb (MenuBar* self,
                                        GtkCheckMenuItem* item);
static void _menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
VALA_EXTERN GtkAccelGroup* menu_bar_get_accel_group (MenuBar* self);
static void menu_bar_screen_reader_toggled_cb (MenuBar* self,
                                        GtkCheckMenuItem* item);
static void _menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static IndicatorObject* menu_bar_load_indicator_file (MenuBar* self,
                                               const gchar* indicator_name);
static IndicatorObject* menu_bar_load_indicator_library (MenuBar* self,
                                                  const gchar* indicator_name);
static void menu_bar_load_indicator (MenuBar* self,
                              const gchar* indicator_name);
static void menu_bar_indicator_added_cb (MenuBar* self,
                                  IndicatorObject* object,
                                  IndicatorObjectEntry* entry);
static void _menu_bar_indicator_added_cb_indicator_object_entry_added (IndicatorObject* _sender,
                                                                IndicatorObjectEntry* entry,
                                                                gpointer self);
static void menu_bar_indicator_removed_cb (MenuBar* self,
                                    IndicatorObject* object,
                                    IndicatorObjectEntry* entry);
static void _menu_bar_indicator_removed_cb_indicator_object_entry_removed (IndicatorObject* _sender,
                                                                    IndicatorObjectEntry* entry,
                                                                    gpointer self);
static void menu_bar_setup_indicators (MenuBar* self);
VALA_EXTERN gchar** ug_settings_get_strv (const gchar* key,
                              gint* result_length1);
VALA_EXTERN gboolean ug_settings_set_strv (const gchar* key,
                               gchar** value,
                               gint value_length1);
static gint __lambda15_ (IndicatorObject* a,
                  IndicatorObject* b);
static gint ___lambda15__gcompare_func (gconstpointer a,
                                 gconstpointer b);
VALA_EXTERN gboolean ug_settings_set_boolean (const gchar* key,
                                  gboolean value);
VALA_EXTERN GtkWindow* menu_bar_get_keyboard_window (MenuBar* self);
static void menu_bar_set_keyboard_window (MenuBar* self,
                                   GtkWindow* value);
static void menu_bar_set_high_contrast (MenuBar* self,
                                 gboolean value);
VALA_EXTERN gboolean menu_bar_get_high_contrast (MenuBar* self);
VALA_EXTERN gpointer unity_greeter_ref (gpointer instance);
VALA_EXTERN void unity_greeter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_unity_greeter (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_unity_greeter (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_unity_greeter (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_unity_greeter (const GValue* value);
VALA_EXTERN GType unity_greeter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UnityGreeter, unity_greeter_unref)
static gboolean ____lambda14_ (MenuBar* self);
static gboolean _____lambda14__gsource_func (gpointer self);
static guint menu_bar_get_indicator_index (MenuBar* self,
                                    IndicatorObject* object);
static IndicatorObject* menu_bar_get_indicator_object_from_entry (MenuBar* self,
                                                           IndicatorObjectEntry* entry);
static void menu_bar_set_background (MenuBar* self,
                              Background* value);
static void menu_bar_set_accel_group (MenuBar* self,
                               GtkAccelGroup* value);
static GObject * menu_bar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static void _menu_bar_cleanup_unity_greeter_starting_session (UnityGreeter* _sender,
                                                       gpointer self);
static void menu_bar_finalize (GObject * obj);
static GType menu_bar_get_type_once (void);
static void _vala_menu_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_menu_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
indicator_menu_item_get_instance_private (IndicatorMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, IndicatorMenuItem_private_offset);
}

static void
_indicator_menu_item_visibility_changed_cb_gtk_widget_show (GtkWidget* _sender,
                                                            gpointer self)
{
#line 35 "menubar.vala"
	indicator_menu_item_visibility_changed_cb ((IndicatorMenuItem*) self, _sender);
#line 349 "menubar.c"
}

static void
_indicator_menu_item_visibility_changed_cb_gtk_widget_hide (GtkWidget* _sender,
                                                            gpointer self)
{
#line 36 "menubar.vala"
	indicator_menu_item_visibility_changed_cb ((IndicatorMenuItem*) self, _sender);
#line 358 "menubar.c"
}

IndicatorMenuItem*
indicator_menu_item_construct (GType object_type,
                               IndicatorObjectEntry* entry)
{
	IndicatorMenuItem * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkLabel* _tmp3_;
	GtkImage* _tmp8_;
	const gchar* _tmp13_;
	GtkMenu* _tmp16_;
#line 26 "menubar.vala"
	g_return_val_if_fail (entry != NULL, NULL);
#line 26 "menubar.vala"
	self = (IndicatorMenuItem*) g_object_new (object_type, NULL);
#line 28 "menubar.vala"
	self->entry = entry;
#line 29 "menubar.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 29 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 29 "menubar.vala"
	_g_object_unref0 (self->priv->hbox);
#line 29 "menubar.vala"
	self->priv->hbox = _tmp0_;
#line 30 "menubar.vala"
	_tmp1_ = self->priv->hbox;
#line 30 "menubar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 31 "menubar.vala"
	_tmp2_ = self->priv->hbox;
#line 31 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp2_);
#line 33 "menubar.vala"
	_tmp3_ = entry->label;
#line 33 "menubar.vala"
	if (_tmp3_ != NULL) {
#line 399 "menubar.c"
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		GtkBox* _tmp6_;
		GtkLabel* _tmp7_;
#line 35 "menubar.vala"
		_tmp4_ = entry->label;
#line 35 "menubar.vala"
		g_signal_connect_object ((GtkWidget*) _tmp4_, "show", (GCallback) _indicator_menu_item_visibility_changed_cb_gtk_widget_show, self, 0);
#line 36 "menubar.vala"
		_tmp5_ = entry->label;
#line 36 "menubar.vala"
		g_signal_connect_object ((GtkWidget*) _tmp5_, "hide", (GCallback) _indicator_menu_item_visibility_changed_cb_gtk_widget_hide, self, 0);
#line 37 "menubar.vala"
		_tmp6_ = self->priv->hbox;
#line 37 "menubar.vala"
		_tmp7_ = entry->label;
#line 37 "menubar.vala"
		gtk_box_pack_start (_tmp6_, (GtkWidget*) _tmp7_, FALSE, FALSE, (guint) 0);
#line 418 "menubar.c"
	}
#line 39 "menubar.vala"
	_tmp8_ = entry->image;
#line 39 "menubar.vala"
	if (_tmp8_ != NULL) {
#line 424 "menubar.c"
		GtkImage* _tmp9_;
		GtkImage* _tmp10_;
		GtkBox* _tmp11_;
		GtkImage* _tmp12_;
#line 41 "menubar.vala"
		_tmp9_ = entry->image;
#line 41 "menubar.vala"
		g_signal_connect_object ((GtkWidget*) _tmp9_, "show", (GCallback) _indicator_menu_item_visibility_changed_cb_gtk_widget_show, self, 0);
#line 42 "menubar.vala"
		_tmp10_ = entry->image;
#line 42 "menubar.vala"
		g_signal_connect_object ((GtkWidget*) _tmp10_, "hide", (GCallback) _indicator_menu_item_visibility_changed_cb_gtk_widget_hide, self, 0);
#line 43 "menubar.vala"
		_tmp11_ = self->priv->hbox;
#line 43 "menubar.vala"
		_tmp12_ = entry->image;
#line 43 "menubar.vala"
		gtk_box_pack_start (_tmp11_, (GtkWidget*) _tmp12_, FALSE, FALSE, (guint) 0);
#line 443 "menubar.c"
	}
#line 45 "menubar.vala"
	_tmp13_ = entry->accessible_desc;
#line 45 "menubar.vala"
	if (_tmp13_ != NULL) {
#line 449 "menubar.c"
		AtkObject* _tmp14_;
		const gchar* _tmp15_;
#line 46 "menubar.vala"
		_tmp14_ = gtk_widget_get_accessible ((GtkWidget*) self);
#line 46 "menubar.vala"
		_tmp15_ = entry->accessible_desc;
#line 46 "menubar.vala"
		atk_object_set_name (_tmp14_, _tmp15_);
#line 458 "menubar.c"
	}
#line 47 "menubar.vala"
	_tmp16_ = entry->menu;
#line 47 "menubar.vala"
	if (_tmp16_ != NULL) {
#line 464 "menubar.c"
		GtkMenu* _tmp17_;
#line 48 "menubar.vala"
		_tmp17_ = entry->menu;
#line 48 "menubar.vala"
		gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp17_);
#line 470 "menubar.c"
	}
#line 50 "menubar.vala"
	if (indicator_menu_item_has_visible_child (self)) {
#line 51 "menubar.vala"
		gtk_widget_show ((GtkWidget*) self);
#line 476 "menubar.c"
	}
#line 26 "menubar.vala"
	return self;
#line 480 "menubar.c"
}

IndicatorMenuItem*
indicator_menu_item_new (IndicatorObjectEntry* entry)
{
#line 26 "menubar.vala"
	return indicator_menu_item_construct (TYPE_INDICATOR_MENU_ITEM, entry);
#line 488 "menubar.c"
}

gboolean
indicator_menu_item_has_visible_child (IndicatorMenuItem* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	IndicatorObjectEntry* _tmp2_;
	GtkImage* _tmp3_;
	gboolean result;
#line 54 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "menubar.vala"
	_tmp2_ = self->entry;
#line 56 "menubar.vala"
	_tmp3_ = _tmp2_->image;
#line 56 "menubar.vala"
	if (_tmp3_ != NULL) {
#line 507 "menubar.c"
		IndicatorObjectEntry* _tmp4_;
		GtkImage* _tmp5_;
#line 56 "menubar.vala"
		_tmp4_ = self->entry;
#line 56 "menubar.vala"
		_tmp5_ = _tmp4_->image;
#line 56 "menubar.vala"
		_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp5_);
#line 516 "menubar.c"
	} else {
#line 56 "menubar.vala"
		_tmp1_ = FALSE;
#line 520 "menubar.c"
	}
#line 56 "menubar.vala"
	if (_tmp1_) {
#line 56 "menubar.vala"
		_tmp0_ = TRUE;
#line 526 "menubar.c"
	} else {
		gboolean _tmp6_ = FALSE;
		IndicatorObjectEntry* _tmp7_;
		GtkLabel* _tmp8_;
#line 57 "menubar.vala"
		_tmp7_ = self->entry;
#line 57 "menubar.vala"
		_tmp8_ = _tmp7_->label;
#line 57 "menubar.vala"
		if (_tmp8_ != NULL) {
#line 537 "menubar.c"
			IndicatorObjectEntry* _tmp9_;
			GtkLabel* _tmp10_;
#line 57 "menubar.vala"
			_tmp9_ = self->entry;
#line 57 "menubar.vala"
			_tmp10_ = _tmp9_->label;
#line 57 "menubar.vala"
			_tmp6_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
#line 546 "menubar.c"
		} else {
#line 57 "menubar.vala"
			_tmp6_ = FALSE;
#line 550 "menubar.c"
		}
#line 57 "menubar.vala"
		_tmp0_ = _tmp6_;
#line 554 "menubar.c"
	}
#line 56 "menubar.vala"
	result = _tmp0_;
#line 56 "menubar.vala"
	return result;
#line 560 "menubar.c"
}

void
indicator_menu_item_visibility_changed_cb (IndicatorMenuItem* self,
                                           GtkWidget* widget)
{
#line 60 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 60 "menubar.vala"
	g_return_if_fail (widget != NULL);
#line 62 "menubar.vala"
	gtk_widget_set_visible ((GtkWidget*) self, indicator_menu_item_has_visible_child (self));
#line 573 "menubar.c"
}

static void
indicator_menu_item_class_init (IndicatorMenuItemClass * klass,
                                gpointer klass_data)
{
#line 21 "menubar.vala"
	indicator_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 21 "menubar.vala"
	g_type_class_adjust_private_offset (klass, &IndicatorMenuItem_private_offset);
#line 21 "menubar.vala"
	G_OBJECT_CLASS (klass)->finalize = indicator_menu_item_finalize;
#line 586 "menubar.c"
}

static void
indicator_menu_item_instance_init (IndicatorMenuItem * self,
                                   gpointer klass)
{
#line 21 "menubar.vala"
	self->priv = indicator_menu_item_get_instance_private (self);
#line 595 "menubar.c"
}

static void
indicator_menu_item_finalize (GObject * obj)
{
	IndicatorMenuItem * self;
#line 21 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INDICATOR_MENU_ITEM, IndicatorMenuItem);
#line 24 "menubar.vala"
	_g_object_unref0 (self->priv->hbox);
#line 21 "menubar.vala"
	G_OBJECT_CLASS (indicator_menu_item_parent_class)->finalize (obj);
#line 608 "menubar.c"
}

static GType
indicator_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorMenuItem), 0, (GInstanceInitFunc) indicator_menu_item_instance_init, NULL };
	GType indicator_menu_item_type_id;
	indicator_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "IndicatorMenuItem", &g_define_type_info, 0);
	IndicatorMenuItem_private_offset = g_type_add_instance_private (indicator_menu_item_type_id, sizeof (IndicatorMenuItemPrivate));
	return indicator_menu_item_type_id;
}

GType
indicator_menu_item_get_type (void)
{
	static volatile gsize indicator_menu_item_type_id__once = 0;
	if (g_once_init_enter (&indicator_menu_item_type_id__once)) {
		GType indicator_menu_item_type_id;
		indicator_menu_item_type_id = indicator_menu_item_get_type_once ();
		g_once_init_leave (&indicator_menu_item_type_id__once, indicator_menu_item_type_id);
	}
	return indicator_menu_item_type_id__once;
}

static inline gpointer
menu_bar_get_instance_private (MenuBar* self)
{
	return G_STRUCT_MEMBER_P (self, MenuBar_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 113 "menubar.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 644 "menubar.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 113 "menubar.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 652 "menubar.c"
}

MenuBar*
menu_bar_construct (GType object_type,
                    Background* bg,
                    GtkAccelGroup* ag)
{
	MenuBar * self = NULL;
#line 75 "menubar.vala"
	g_return_val_if_fail (bg != NULL, NULL);
#line 75 "menubar.vala"
	g_return_val_if_fail (ag != NULL, NULL);
#line 77 "menubar.vala"
	self = (MenuBar*) g_object_new (object_type, "background", bg, "accel-group", ag, NULL);
#line 75 "menubar.vala"
	return self;
#line 669 "menubar.c"
}

MenuBar*
menu_bar_new (Background* bg,
              GtkAccelGroup* ag)
{
#line 75 "menubar.vala"
	return menu_bar_construct (TYPE_MENU_BAR, bg, ag);
#line 678 "menubar.c"
}

static gboolean
menu_bar_real_draw (GtkWidget* base,
                    cairo_t* c)
{
	MenuBar * self;
	Background* _tmp0_;
	GList* _tmp5_;
	gboolean result;
#line 80 "menubar.vala"
	self = (MenuBar*) base;
#line 80 "menubar.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 82 "menubar.vala"
	_tmp0_ = self->priv->_background;
#line 82 "menubar.vala"
	if (_tmp0_ != NULL) {
#line 697 "menubar.c"
		gint x = 0;
		gint y = 0;
		Background* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		Background* _tmp4_;
#line 85 "menubar.vala"
		_tmp1_ = self->priv->_background;
#line 85 "menubar.vala"
		gtk_widget_translate_coordinates ((GtkWidget*) _tmp1_, (GtkWidget*) self, 0, 0, &_tmp2_, &_tmp3_);
#line 85 "menubar.vala"
		x = _tmp2_;
#line 85 "menubar.vala"
		y = _tmp3_;
#line 86 "menubar.vala"
		cairo_save (c);
#line 87 "menubar.vala"
		cairo_translate (c, (gdouble) x, (gdouble) y);
#line 88 "menubar.vala"
		_tmp4_ = self->priv->_background;
#line 88 "menubar.vala"
		background_draw_full (_tmp4_, c, BACKGROUND_DRAW_FLAGS_NONE);
#line 89 "menubar.vala"
		cairo_restore (c);
#line 722 "menubar.c"
	}
#line 92 "menubar.vala"
	cairo_set_source_rgb (c, 0.1, 0.1, 0.1);
#line 93 "menubar.vala"
	cairo_paint_with_alpha (c, 0.4);
#line 95 "menubar.vala"
	_tmp5_ = gtk_container_get_children ((GtkContainer*) self);
#line 730 "menubar.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 95 "menubar.vala"
		child_collection = _tmp5_;
#line 95 "menubar.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 738 "menubar.c"
			GtkWidget* child = NULL;
#line 95 "menubar.vala"
			child = (GtkWidget*) child_it->data;
#line 742 "menubar.c"
			{
				GtkWidget* _tmp6_;
#line 97 "menubar.vala"
				_tmp6_ = child;
#line 97 "menubar.vala"
				gtk_container_propagate_draw ((GtkContainer*) self, _tmp6_, c);
#line 749 "menubar.c"
			}
		}
#line 95 "menubar.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 754 "menubar.c"
	}
#line 100 "menubar.vala"
	result = FALSE;
#line 100 "menubar.vala"
	return result;
#line 760 "menubar.c"
}

void
menu_bar_set_keyboard_state (MenuBar* self)
{
	GtkCheckMenuItem* _tmp0_;
#line 107 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 109 "menubar.vala"
	_tmp0_ = self->priv->onscreen_keyboard_item;
#line 109 "menubar.vala"
	gtk_check_menu_item_set_active (_tmp0_, ug_settings_get_boolean (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD));
#line 773 "menubar.c"
}

static void
menu_bar_close_pid (MenuBar* self,
                    GPid* pid)
{
#line 159 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 161 "menubar.vala"
	if ((*pid) > ((GPid) 0)) {
#line 784 "menubar.c"
		gint status = 0;
		gint _tmp0_ = 0;
#line 163 "menubar.vala"
		kill ((pid_t) (*pid), SIGTERM);
#line 165 "menubar.vala"
		waitpid ((pid_t) (*pid), &_tmp0_, 0);
#line 165 "menubar.vala"
		status = _tmp0_;
#line 166 "menubar.vala"
		*pid = (GPid) 0;
#line 795 "menubar.c"
	}
}

void
menu_bar_cleanup (MenuBar* self)
{
#line 170 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 172 "menubar.vala"
	menu_bar_close_pid (self, &self->priv->keyboard_pid);
#line 173 "menubar.vala"
	menu_bar_close_pid (self, &self->priv->reader_pid);
#line 808 "menubar.c"
}

static void
menu_bar_real_get_preferred_height (GtkWidget* base,
                                    gint* min,
                                    gint* nat)
{
	MenuBar * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 176 "menubar.vala"
	self = (MenuBar*) base;
#line 178 "menubar.vala"
	_vala_min = MENU_BAR_HEIGHT;
#line 179 "menubar.vala"
	_vala_nat = MENU_BAR_HEIGHT;
#line 176 "menubar.vala"
	if (min) {
#line 176 "menubar.vala"
		*min = _vala_min;
#line 829 "menubar.c"
	}
#line 176 "menubar.vala"
	if (nat) {
#line 176 "menubar.vala"
		*nat = _vala_nat;
#line 835 "menubar.c"
	}
}

static void
menu_bar_greeter_set_env (MenuBar* self,
                          const gchar* key,
                          const gchar* val)
{
	GError* _inner_error0_ = NULL;
#line 182 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 182 "menubar.vala"
	g_return_if_fail (key != NULL);
#line 182 "menubar.vala"
	g_return_if_fail (val != NULL);
#line 184 "menubar.vala"
	g_setenv (key, val, TRUE);
#line 853 "menubar.c"
	{
		GDBusProxy* proxy = NULL;
		GDBusProxy* _tmp0_;
		GVariantBuilder* builder = NULL;
		const GVariantType* _tmp1_;
		GVariantBuilder* _tmp2_;
		GVariantBuilder* _tmp3_;
		GDBusProxy* _tmp4_;
		GVariantBuilder* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
#line 190 "menubar.vala"
		_tmp0_ = g_dbus_proxy_new_for_bus_sync (G_BUS_TYPE_SESSION, G_DBUS_PROXY_FLAGS_NONE, NULL, "org.freedesktop.DBus", "/org/freedesktop/DBus", "org.freedesktop.DBus", NULL, &_inner_error0_);
#line 190 "menubar.vala"
		proxy = _tmp0_;
#line 190 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 873 "menubar.c"
			goto __catch0_g_error;
		}
#line 197 "menubar.vala"
		_tmp1_ = G_VARIANT_TYPE_ARRAY;
#line 197 "menubar.vala"
		_tmp2_ = g_variant_builder_new (_tmp1_);
#line 197 "menubar.vala"
		builder = _tmp2_;
#line 198 "menubar.vala"
		_tmp3_ = builder;
#line 198 "menubar.vala"
		g_variant_builder_add (_tmp3_, "{ss}", key, val, NULL);
#line 200 "menubar.vala"
		_tmp4_ = proxy;
#line 200 "menubar.vala"
		_tmp5_ = builder;
#line 200 "menubar.vala"
		_tmp6_ = g_variant_new ("(a{ss})", _tmp5_, NULL);
#line 200 "menubar.vala"
		g_variant_ref_sink (_tmp6_);
#line 200 "menubar.vala"
		_tmp7_ = _tmp6_;
#line 200 "menubar.vala"
		_tmp8_ = g_dbus_proxy_call_sync (_tmp4_, "UpdateActivationEnvironment", _tmp7_, G_DBUS_CALL_FLAGS_NONE, -1, NULL, &_inner_error0_);
#line 200 "menubar.vala"
		_tmp9_ = _tmp8_;
#line 200 "menubar.vala"
		_g_variant_unref0 (_tmp9_);
#line 200 "menubar.vala"
		_g_variant_unref0 (_tmp7_);
#line 200 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "menubar.vala"
			_g_variant_builder_unref0 (builder);
#line 200 "menubar.vala"
			_g_object_unref0 (proxy);
#line 910 "menubar.c"
			goto __catch0_g_error;
		}
#line 188 "menubar.vala"
		_g_variant_builder_unref0 (builder);
#line 188 "menubar.vala"
		_g_object_unref0 (proxy);
#line 917 "menubar.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 188 "menubar.vala"
		e = _inner_error0_;
#line 188 "menubar.vala"
		_inner_error0_ = NULL;
#line 204 "menubar.vala"
		_tmp10_ = e;
#line 204 "menubar.vala"
		_tmp11_ = _tmp10_->message;
#line 204 "menubar.vala"
		g_warning ("menubar.vala:204: Could not get set environment for indicators: %s", _tmp11_);
#line 205 "menubar.vala"
		_g_error_free0 (e);
#line 205 "menubar.vala"
		return;
#line 939 "menubar.c"
	}
	__finally0:
#line 188 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 188 "menubar.vala"
		return;
#line 950 "menubar.c"
	}
}

static void
_menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                           gpointer self)
{
#line 221 "menubar.vala"
	menu_bar_keyboard_toggled_cb ((MenuBar*) self, _sender);
#line 960 "menubar.c"
}

static void
_menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 226 "menubar.vala"
	menu_bar_high_contrast_toggled_cb ((MenuBar*) self, _sender);
#line 969 "menubar.c"
}

static void
_menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 232 "menubar.vala"
	menu_bar_screen_reader_toggled_cb ((MenuBar*) self, _sender);
#line 978 "menubar.c"
}

static GtkWidget*
menu_bar_make_a11y_indicator (MenuBar* self)
{
	GtkMenuItem* a11y_item = NULL;
	GtkMenuItem* _tmp0_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp1_;
	GtkImage* image = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkCheckMenuItem* _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	GtkCheckMenuItem* _tmp10_;
	GtkMenu* submenu = NULL;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkCheckMenuItem* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkCheckMenuItem* _tmp15_;
	GtkCheckMenuItem* _tmp16_;
	GtkAccelGroup* _tmp17_;
	GtkCheckMenuItem* _tmp18_;
	GtkCheckMenuItem* _tmp19_;
	GtkCheckMenuItem* _tmp20_;
	GtkCheckMenuItem* item = NULL;
	GtkCheckMenuItem* _tmp21_;
	GtkAccelGroup* _tmp22_;
	GtkWidget* result;
#line 209 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 211 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 211 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 211 "menubar.vala"
	a11y_item = _tmp0_;
#line 212 "menubar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 212 "menubar.vala"
	g_object_ref_sink (_tmp1_);
#line 212 "menubar.vala"
	hbox = _tmp1_;
#line 213 "menubar.vala"
	gtk_widget_show ((GtkWidget*) hbox);
#line 214 "menubar.vala"
	gtk_container_add ((GtkContainer*) a11y_item, (GtkWidget*) hbox);
#line 215 "menubar.vala"
	_tmp2_ = g_build_filename (PKGDATADIR, "a11y.svg", NULL);
#line 215 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 215 "menubar.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_file (_tmp3_);
#line 215 "menubar.vala"
	g_object_ref_sink (_tmp4_);
#line 215 "menubar.vala"
	_tmp5_ = _tmp4_;
#line 215 "menubar.vala"
	_g_free0 (_tmp3_);
#line 215 "menubar.vala"
	image = _tmp5_;
#line 216 "menubar.vala"
	gtk_widget_show ((GtkWidget*) image);
#line 217 "menubar.vala"
	gtk_container_add ((GtkContainer*) hbox, (GtkWidget*) image);
#line 218 "menubar.vala"
	gtk_widget_show ((GtkWidget*) a11y_item);
#line 219 "menubar.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 219 "menubar.vala"
	g_object_ref_sink (_tmp6_);
#line 219 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 219 "menubar.vala"
	gtk_menu_item_set_submenu (a11y_item, _tmp7_);
#line 219 "menubar.vala"
	_g_object_unref0 (_tmp7_);
#line 220 "menubar.vala"
	_tmp8_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Onscreen keyboard"));
#line 220 "menubar.vala"
	g_object_ref_sink (_tmp8_);
#line 220 "menubar.vala"
	_g_object_unref0 (self->priv->onscreen_keyboard_item);
#line 220 "menubar.vala"
	self->priv->onscreen_keyboard_item = _tmp8_;
#line 221 "menubar.vala"
	_tmp9_ = self->priv->onscreen_keyboard_item;
#line 221 "menubar.vala"
	g_signal_connect_object (_tmp9_, "toggled", (GCallback) _menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 222 "menubar.vala"
	_tmp10_ = self->priv->onscreen_keyboard_item;
#line 222 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 223 "menubar.vala"
	_tmp11_ = gtk_menu_item_get_submenu (a11y_item);
#line 223 "menubar.vala"
	_tmp12_ = _tmp11_;
#line 223 "menubar.vala"
	submenu = _tmp12_;
#line 224 "menubar.vala"
	_tmp13_ = self->priv->onscreen_keyboard_item;
#line 224 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) _tmp13_);
#line 225 "menubar.vala"
	_tmp14_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("High Contrast"));
#line 225 "menubar.vala"
	g_object_ref_sink (_tmp14_);
#line 225 "menubar.vala"
	_g_object_unref0 (self->priv->high_contrast_item);
#line 225 "menubar.vala"
	self->priv->high_contrast_item = _tmp14_;
#line 226 "menubar.vala"
	_tmp15_ = self->priv->high_contrast_item;
#line 226 "menubar.vala"
	g_signal_connect_object (_tmp15_, "toggled", (GCallback) _menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 227 "menubar.vala"
	_tmp16_ = self->priv->high_contrast_item;
#line 227 "menubar.vala"
	_tmp17_ = self->priv->_accel_group;
#line 227 "menubar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) _tmp16_, "activate", _tmp17_, GDK_KEY_h, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
#line 228 "menubar.vala"
	_tmp18_ = self->priv->high_contrast_item;
#line 228 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp18_);
#line 229 "menubar.vala"
	_tmp19_ = self->priv->high_contrast_item;
#line 229 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) _tmp19_);
#line 230 "menubar.vala"
	_tmp20_ = self->priv->high_contrast_item;
#line 230 "menubar.vala"
	gtk_check_menu_item_set_active (_tmp20_, ug_settings_get_boolean (UG_SETTINGS_KEY_HIGH_CONTRAST));
#line 231 "menubar.vala"
	_tmp21_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Screen Reader"));
#line 231 "menubar.vala"
	g_object_ref_sink (_tmp21_);
#line 231 "menubar.vala"
	item = _tmp21_;
#line 232 "menubar.vala"
	g_signal_connect_object (item, "toggled", (GCallback) _menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 233 "menubar.vala"
	_tmp22_ = self->priv->_accel_group;
#line 233 "menubar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) item, "activate", _tmp22_, GDK_KEY_s, GDK_SUPER_MASK | GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
#line 234 "menubar.vala"
	gtk_widget_show ((GtkWidget*) item);
#line 235 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) item);
#line 236 "menubar.vala"
	gtk_check_menu_item_set_active (item, ug_settings_get_boolean (UG_SETTINGS_KEY_SCREEN_READER));
#line 237 "menubar.vala"
	result = (GtkWidget*) a11y_item;
#line 237 "menubar.vala"
	_g_object_unref0 (item);
#line 237 "menubar.vala"
	_g_object_unref0 (image);
#line 237 "menubar.vala"
	_g_object_unref0 (hbox);
#line 237 "menubar.vala"
	return result;
#line 1145 "menubar.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1167 "menubar.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 1175 "menubar.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 1181 "menubar.c"
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 1195 "menubar.c"
}

static IndicatorObject*
menu_bar_load_indicator_file (MenuBar* self,
                              const gchar* indicator_name)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	IndicatorObject* io = NULL;
	GError* _inner_error0_ = NULL;
	IndicatorObject* result;
#line 240 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 240 "menubar.vala"
	g_return_val_if_fail (indicator_name != NULL, NULL);
#line 242 "menubar.vala"
	_tmp0_ = g_strdup (INDICATOR_FILE_DIR);
#line 242 "menubar.vala"
	dir = _tmp0_;
#line 247 "menubar.vala"
	if (string_index_of_char (indicator_name, (gunichar) '.', 0) < 0) {
#line 1218 "menubar.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 248 "menubar.vala"
		_tmp1_ = dir;
#line 248 "menubar.vala"
		_tmp2_ = string_to_string (_tmp1_);
#line 248 "menubar.vala"
		_tmp3_ = string_to_string (indicator_name);
#line 248 "menubar.vala"
		_tmp4_ = g_strconcat (_tmp2_, "/com.canonical.indicator.", _tmp3_, NULL);
#line 248 "menubar.vala"
		_g_free0 (path);
#line 248 "menubar.vala"
		path = _tmp4_;
#line 1235 "menubar.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 250 "menubar.vala"
		_tmp5_ = dir;
#line 250 "menubar.vala"
		_tmp6_ = string_to_string (_tmp5_);
#line 250 "menubar.vala"
		_tmp7_ = string_to_string (indicator_name);
#line 250 "menubar.vala"
		_tmp8_ = g_strconcat (_tmp6_, "/", _tmp7_, NULL);
#line 250 "menubar.vala"
		_g_free0 (path);
#line 250 "menubar.vala"
		path = _tmp8_;
#line 1253 "menubar.c"
	}
	{
		IndicatorNg* _tmp9_ = NULL;
		const gchar* _tmp10_;
		IndicatorNg* _tmp11_;
		IndicatorNg* _tmp12_;
#line 254 "menubar.vala"
		_tmp10_ = path;
#line 254 "menubar.vala"
		_tmp11_ = indicator_ng_new_for_profile (_tmp10_, "desktop_greeter", &_inner_error0_);
#line 254 "menubar.vala"
		_tmp9_ = _tmp11_;
#line 254 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "menubar.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1270 "menubar.c"
				goto __catch0_g_file_error;
			}
			goto __catch0_g_error;
		}
#line 254 "menubar.vala"
		_tmp12_ = _tmp9_;
#line 254 "menubar.vala"
		_tmp9_ = NULL;
#line 254 "menubar.vala"
		_g_object_unref0 (io);
#line 254 "menubar.vala"
		io = (IndicatorObject*) _tmp12_;
#line 252 "menubar.vala"
		_g_object_unref0 (_tmp9_);
#line 1285 "menubar.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 252 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 259 "menubar.vala"
		result = NULL;
#line 259 "menubar.vala"
		_g_object_unref0 (io);
#line 259 "menubar.vala"
		_g_free0 (path);
#line 259 "menubar.vala"
		_g_free0 (dir);
#line 259 "menubar.vala"
		return result;
#line 1302 "menubar.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 252 "menubar.vala"
		_error_ = _inner_error0_;
#line 252 "menubar.vala"
		_inner_error0_ = NULL;
#line 263 "menubar.vala"
		_tmp13_ = _error_;
#line 263 "menubar.vala"
		_tmp14_ = _tmp13_->message;
#line 263 "menubar.vala"
		g_warning ("menubar.vala:263: unable to load %s: %s", indicator_name, _tmp14_);
#line 264 "menubar.vala"
		result = NULL;
#line 264 "menubar.vala"
		_g_error_free0 (_error_);
#line 264 "menubar.vala"
		_g_object_unref0 (io);
#line 264 "menubar.vala"
		_g_free0 (path);
#line 264 "menubar.vala"
		_g_free0 (dir);
#line 264 "menubar.vala"
		return result;
#line 1332 "menubar.c"
	}
	__finally0:
#line 252 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "menubar.vala"
		_g_object_unref0 (io);
#line 252 "menubar.vala"
		_g_free0 (path);
#line 252 "menubar.vala"
		_g_free0 (dir);
#line 252 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 252 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 252 "menubar.vala"
		return NULL;
#line 1349 "menubar.c"
	}
#line 267 "menubar.vala"
	result = io;
#line 267 "menubar.vala"
	_g_free0 (path);
#line 267 "menubar.vala"
	_g_free0 (dir);
#line 267 "menubar.vala"
	return result;
#line 1359 "menubar.c"
}

static IndicatorObject*
menu_bar_load_indicator_library (MenuBar* self,
                                 const gchar* indicator_name)
{
	gchar** names_to_try = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint names_to_try_length1;
	gint _names_to_try_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	IndicatorObject* result;
#line 270 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 270 "menubar.vala"
	g_return_val_if_fail (indicator_name != NULL, NULL);
#line 273 "menubar.vala"
	_tmp0_ = g_strconcat ("lib", indicator_name, NULL);
#line 273 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 273 "menubar.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".so", NULL);
#line 273 "menubar.vala"
	_tmp3_ = g_strconcat (indicator_name, ".so", NULL);
#line 273 "menubar.vala"
	_tmp4_ = g_strdup (indicator_name);
#line 273 "menubar.vala"
	_tmp5_ = g_new0 (gchar*, 3 + 1);
#line 273 "menubar.vala"
	_tmp5_[0] = _tmp2_;
#line 273 "menubar.vala"
	_tmp5_[1] = _tmp3_;
#line 273 "menubar.vala"
	_tmp5_[2] = _tmp4_;
#line 273 "menubar.vala"
	_tmp6_ = _tmp5_;
#line 273 "menubar.vala"
	_tmp6__length1 = 3;
#line 273 "menubar.vala"
	_g_free0 (_tmp1_);
#line 273 "menubar.vala"
	names_to_try = _tmp6_;
#line 273 "menubar.vala"
	names_to_try_length1 = _tmp6__length1;
#line 273 "menubar.vala"
	_names_to_try_size_ = names_to_try_length1;
#line 276 "menubar.vala"
	_tmp7_ = names_to_try;
#line 276 "menubar.vala"
	_tmp7__length1 = names_to_try_length1;
#line 1418 "menubar.c"
	{
		gchar** filename_collection = NULL;
		gint filename_collection_length1 = 0;
		gint _filename_collection_size_ = 0;
		gint filename_it = 0;
#line 276 "menubar.vala"
		filename_collection = _tmp7_;
#line 276 "menubar.vala"
		filename_collection_length1 = _tmp7__length1;
#line 276 "menubar.vala"
		for (filename_it = 0; filename_it < filename_collection_length1; filename_it = filename_it + 1) {
#line 1430 "menubar.c"
			gchar* _tmp8_;
			gchar* filename = NULL;
#line 276 "menubar.vala"
			_tmp8_ = g_strdup (filename_collection[filename_it]);
#line 276 "menubar.vala"
			filename = _tmp8_;
#line 1437 "menubar.c"
			{
				gchar* full_path = NULL;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				IndicatorObject* io = NULL;
				const gchar* _tmp11_;
				IndicatorObject* _tmp12_;
				IndicatorObject* _tmp13_;
#line 278 "menubar.vala"
				_tmp9_ = filename;
#line 278 "menubar.vala"
				_tmp10_ = g_build_filename (INDICATORDIR, _tmp9_, NULL);
#line 278 "menubar.vala"
				full_path = _tmp10_;
#line 279 "menubar.vala"
				_tmp11_ = full_path;
#line 279 "menubar.vala"
				_tmp12_ = indicator_object_new_from_file (_tmp11_);
#line 279 "menubar.vala"
				io = _tmp12_;
#line 280 "menubar.vala"
				_tmp13_ = io;
#line 280 "menubar.vala"
				if (_tmp13_ != NULL) {
#line 281 "menubar.vala"
					result = io;
#line 281 "menubar.vala"
					_g_free0 (full_path);
#line 281 "menubar.vala"
					_g_free0 (filename);
#line 281 "menubar.vala"
					names_to_try = (_vala_array_free (names_to_try, names_to_try_length1, (GDestroyNotify) g_free), NULL);
#line 281 "menubar.vala"
					return result;
#line 1472 "menubar.c"
				}
#line 276 "menubar.vala"
				_g_object_unref0 (io);
#line 276 "menubar.vala"
				_g_free0 (full_path);
#line 276 "menubar.vala"
				_g_free0 (filename);
#line 1480 "menubar.c"
			}
		}
	}
#line 284 "menubar.vala"
	result = NULL;
#line 284 "menubar.vala"
	names_to_try = (_vala_array_free (names_to_try, names_to_try_length1, (GDestroyNotify) g_free), NULL);
#line 284 "menubar.vala"
	return result;
#line 1490 "menubar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 303 "menubar.vala"
	return self ? g_object_ref (self) : NULL;
#line 1498 "menubar.c"
}

static void
_menu_bar_indicator_added_cb_indicator_object_entry_added (IndicatorObject* _sender,
                                                           IndicatorObjectEntry* entry,
                                                           gpointer self)
{
#line 304 "menubar.vala"
	menu_bar_indicator_added_cb ((MenuBar*) self, _sender, entry);
#line 1508 "menubar.c"
}

static void
_menu_bar_indicator_removed_cb_indicator_object_entry_removed (IndicatorObject* _sender,
                                                               IndicatorObjectEntry* entry,
                                                               gpointer self)
{
#line 305 "menubar.vala"
	menu_bar_indicator_removed_cb ((MenuBar*) self, _sender, entry);
#line 1518 "menubar.c"
}

static void
menu_bar_load_indicator (MenuBar* self,
                         const gchar* indicator_name)
{
#line 287 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 287 "menubar.vala"
	g_return_if_fail (indicator_name != NULL);
#line 289 "menubar.vala"
	if (g_strcmp0 (indicator_name, "ug-accessibility") == 0) {
#line 1531 "menubar.c"
		GtkWidget* a11y_item = NULL;
		GtkWidget* _tmp0_;
		GtkWidget* _tmp1_;
		GList* _tmp2_;
		GList* _tmp3_;
#line 291 "menubar.vala"
		_tmp0_ = menu_bar_make_a11y_indicator (self);
#line 291 "menubar.vala"
		a11y_item = _tmp0_;
#line 292 "menubar.vala"
		_tmp1_ = a11y_item;
#line 292 "menubar.vala"
		_tmp2_ = gtk_container_get_children ((GtkContainer*) self);
#line 292 "menubar.vala"
		_tmp3_ = _tmp2_;
#line 292 "menubar.vala"
		gtk_menu_shell_insert ((GtkMenuShell*) self, _tmp1_, ((gint) g_list_length (_tmp3_)) - 1);
#line 292 "menubar.vala"
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 289 "menubar.vala"
		_g_object_unref0 (a11y_item);
#line 1553 "menubar.c"
	} else {
		IndicatorObject* io = NULL;
		IndicatorObject* _tmp4_;
		IndicatorObject* _tmp5_;
		IndicatorObject* _tmp7_;
#line 296 "menubar.vala"
		_tmp4_ = menu_bar_load_indicator_file (self, indicator_name);
#line 296 "menubar.vala"
		io = _tmp4_;
#line 298 "menubar.vala"
		_tmp5_ = io;
#line 298 "menubar.vala"
		if (_tmp5_ == NULL) {
#line 1567 "menubar.c"
			IndicatorObject* _tmp6_;
#line 299 "menubar.vala"
			_tmp6_ = menu_bar_load_indicator_library (self, indicator_name);
#line 299 "menubar.vala"
			_g_object_unref0 (io);
#line 299 "menubar.vala"
			io = _tmp6_;
#line 1575 "menubar.c"
		}
#line 301 "menubar.vala"
		_tmp7_ = io;
#line 301 "menubar.vala"
		if (_tmp7_ != NULL) {
#line 1581 "menubar.c"
			IndicatorObject* _tmp8_;
			IndicatorObject* _tmp9_;
			IndicatorObject* _tmp10_;
			IndicatorObject* _tmp11_;
			IndicatorObject* _tmp12_;
			GList* _tmp13_;
#line 303 "menubar.vala"
			_tmp8_ = io;
#line 303 "menubar.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 303 "menubar.vala"
			self->priv->indicator_objects = g_list_append (self->priv->indicator_objects, _tmp9_);
#line 304 "menubar.vala"
			_tmp10_ = io;
#line 304 "menubar.vala"
			g_signal_connect_object (_tmp10_, "entry-added", (GCallback) _menu_bar_indicator_added_cb_indicator_object_entry_added, self, 0);
#line 305 "menubar.vala"
			_tmp11_ = io;
#line 305 "menubar.vala"
			g_signal_connect_object (_tmp11_, "entry-removed", (GCallback) _menu_bar_indicator_removed_cb_indicator_object_entry_removed, self, 0);
#line 306 "menubar.vala"
			_tmp12_ = io;
#line 306 "menubar.vala"
			_tmp13_ = indicator_object_get_entries (_tmp12_);
#line 1606 "menubar.c"
			{
				GList* entry_collection = NULL;
				GList* entry_it = NULL;
#line 306 "menubar.vala"
				entry_collection = _tmp13_;
#line 306 "menubar.vala"
				for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 1614 "menubar.c"
					IndicatorObjectEntry* entry = NULL;
#line 306 "menubar.vala"
					entry = (IndicatorObjectEntry*) entry_it->data;
#line 1618 "menubar.c"
					{
						IndicatorObject* _tmp14_;
						IndicatorObjectEntry* _tmp15_;
#line 307 "menubar.vala"
						_tmp14_ = io;
#line 307 "menubar.vala"
						_tmp15_ = entry;
#line 307 "menubar.vala"
						menu_bar_indicator_added_cb (self, _tmp14_, _tmp15_);
#line 1628 "menubar.c"
					}
				}
#line 306 "menubar.vala"
				(entry_collection == NULL) ? NULL : (entry_collection = (g_list_free (entry_collection), NULL));
#line 1633 "menubar.c"
			}
		}
#line 289 "menubar.vala"
		_g_object_unref0 (io);
#line 1638 "menubar.c"
	}
}

static gint
__lambda15_ (IndicatorObject* a,
             IndicatorObject* b)
{
	gint pos_a = 0;
	gint pos_b = 0;
	gint result;
#line 355 "menubar.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 355 "menubar.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 356 "menubar.vala"
	pos_a = indicator_object_get_position (a);
#line 357 "menubar.vala"
	pos_b = indicator_object_get_position (b);
#line 359 "menubar.vala"
	if (pos_a < 0) {
#line 360 "menubar.vala"
		pos_a = 1000;
#line 1661 "menubar.c"
	}
#line 361 "menubar.vala"
	if (pos_b < 0) {
#line 362 "menubar.vala"
		pos_b = 1000;
#line 1667 "menubar.c"
	}
#line 364 "menubar.vala"
	result = pos_a - pos_b;
#line 364 "menubar.vala"
	return result;
#line 1673 "menubar.c"
}

static gint
___lambda15__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda15_ ((IndicatorObject*) a, (IndicatorObject*) b);
#line 355 "menubar.vala"
	return result;
#line 1684 "menubar.c"
}

static void
menu_bar_setup_indicators (MenuBar* self)
{
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** indicator_list = NULL;
	gint _tmp6_ = 0;
	gchar** _tmp7_;
	gint indicator_list_length1;
	gint _indicator_list_size_;
	gboolean update_indicator_list = FALSE;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 312 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 315 "menubar.vala"
	menu_bar_greeter_set_env (self, "INDICATOR_GREETER_MODE", "1");
#line 318 "menubar.vala"
	menu_bar_greeter_set_env (self, "GIO_USE_VFS", "local");
#line 319 "menubar.vala"
	menu_bar_greeter_set_env (self, "GVFS_DISABLE_FUSE", "1");
#line 322 "menubar.vala"
	menu_bar_greeter_set_env (self, "RUNNING_UNDER_GDM", "1");
#line 1713 "menubar.c"
	{
		GDBusConnection* conn = NULL;
		GDBusConnection* _tmp0_;
		const gchar* _tmp1_;
#line 327 "menubar.vala"
		_tmp0_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
#line 327 "menubar.vala"
		conn = _tmp0_;
#line 327 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 327 "menubar.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 1726 "menubar.c"
				goto __catch0_g_io_error;
			}
#line 327 "menubar.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 327 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 327 "menubar.vala"
			return;
#line 1735 "menubar.c"
		}
#line 328 "menubar.vala"
		_tmp1_ = g_dbus_connection_get_unique_name (conn);
#line 328 "menubar.vala"
		menu_bar_greeter_set_env (self, "UNITY_GREETER_DBUS_NAME", _tmp1_);
#line 325 "menubar.vala"
		_g_object_unref0 (conn);
#line 1743 "menubar.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 325 "menubar.vala"
		e = _inner_error0_;
#line 325 "menubar.vala"
		_inner_error0_ = NULL;
#line 332 "menubar.vala"
		_tmp2_ = e;
#line 332 "menubar.vala"
		_tmp3_ = _tmp2_->message;
#line 332 "menubar.vala"
		g_debug ("menubar.vala:332: Could not set DBUS_NAME: %s", _tmp3_);
#line 325 "menubar.vala"
		_g_error_free0 (e);
#line 1763 "menubar.c"
	}
	__finally0:
#line 325 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 325 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 325 "menubar.vala"
		return;
#line 1774 "menubar.c"
	}
#line 335 "menubar.vala"
	_tmp4_ = g_getenv ("LANG");
#line 335 "menubar.vala"
	_tmp5_ = g_getenv ("LANGUAGE");
#line 335 "menubar.vala"
	g_debug ("menubar.vala:335: LANG=%s LANGUAGE=%s", _tmp4_, _tmp5_);
#line 337 "menubar.vala"
	_tmp7_ = ug_settings_get_strv (UG_SETTINGS_KEY_INDICATORS, &_tmp6_);
#line 337 "menubar.vala"
	indicator_list = _tmp7_;
#line 337 "menubar.vala"
	indicator_list_length1 = _tmp6_;
#line 337 "menubar.vala"
	_indicator_list_size_ = indicator_list_length1;
#line 339 "menubar.vala"
	update_indicator_list = FALSE;
#line 1792 "menubar.c"
	{
		gint i = 0;
#line 340 "menubar.vala"
		i = 0;
#line 1797 "menubar.c"
		{
			gboolean _tmp8_ = FALSE;
#line 340 "menubar.vala"
			_tmp8_ = TRUE;
#line 340 "menubar.vala"
			while (TRUE) {
#line 1804 "menubar.c"
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
#line 340 "menubar.vala"
				if (!_tmp8_) {
#line 1812 "menubar.c"
					gint _tmp9_;
#line 340 "menubar.vala"
					_tmp9_ = i;
#line 340 "menubar.vala"
					i = _tmp9_ + 1;
#line 1818 "menubar.c"
				}
#line 340 "menubar.vala"
				_tmp8_ = FALSE;
#line 340 "menubar.vala"
				_tmp10_ = indicator_list;
#line 340 "menubar.vala"
				_tmp10__length1 = indicator_list_length1;
#line 340 "menubar.vala"
				if (!(i < _tmp10__length1)) {
#line 340 "menubar.vala"
					break;
#line 1830 "menubar.c"
				}
#line 342 "menubar.vala"
				_tmp11_ = indicator_list;
#line 342 "menubar.vala"
				_tmp11__length1 = indicator_list_length1;
#line 342 "menubar.vala"
				_tmp12_ = _tmp11_[i];
#line 342 "menubar.vala"
				if (g_strcmp0 (_tmp12_, "ug-keyboard") == 0) {
#line 1840 "menubar.c"
					gchar** _tmp13_;
					gint _tmp13__length1;
					gchar* _tmp14_;
#line 344 "menubar.vala"
					_tmp13_ = indicator_list;
#line 344 "menubar.vala"
					_tmp13__length1 = indicator_list_length1;
#line 344 "menubar.vala"
					_tmp14_ = g_strdup ("com.canonical.indicator.keyboard");
#line 344 "menubar.vala"
					_g_free0 (_tmp13_[i]);
#line 344 "menubar.vala"
					_tmp13_[i] = _tmp14_;
#line 345 "menubar.vala"
					update_indicator_list = TRUE;
#line 1856 "menubar.c"
				}
			}
		}
	}
#line 349 "menubar.vala"
	if (update_indicator_list) {
#line 1863 "menubar.c"
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 350 "menubar.vala"
		_tmp15_ = indicator_list;
#line 350 "menubar.vala"
		_tmp15__length1 = indicator_list_length1;
#line 350 "menubar.vala"
		ug_settings_set_strv (UG_SETTINGS_KEY_INDICATORS, _tmp15_, (gint) _tmp15__length1);
#line 1872 "menubar.c"
	}
#line 352 "menubar.vala"
	_tmp16_ = indicator_list;
#line 352 "menubar.vala"
	_tmp16__length1 = indicator_list_length1;
#line 1878 "menubar.c"
	{
		gchar** indicator_collection = NULL;
		gint indicator_collection_length1 = 0;
		gint _indicator_collection_size_ = 0;
		gint indicator_it = 0;
#line 352 "menubar.vala"
		indicator_collection = _tmp16_;
#line 352 "menubar.vala"
		indicator_collection_length1 = _tmp16__length1;
#line 352 "menubar.vala"
		for (indicator_it = 0; indicator_it < indicator_collection_length1; indicator_it = indicator_it + 1) {
#line 1890 "menubar.c"
			gchar* _tmp17_;
			gchar* indicator = NULL;
#line 352 "menubar.vala"
			_tmp17_ = g_strdup (indicator_collection[indicator_it]);
#line 352 "menubar.vala"
			indicator = _tmp17_;
#line 1897 "menubar.c"
			{
				const gchar* _tmp18_;
#line 353 "menubar.vala"
				_tmp18_ = indicator;
#line 353 "menubar.vala"
				menu_bar_load_indicator (self, _tmp18_);
#line 352 "menubar.vala"
				_g_free0 (indicator);
#line 1906 "menubar.c"
			}
		}
	}
#line 355 "menubar.vala"
	self->priv->indicator_objects = g_list_sort (self->priv->indicator_objects, ___lambda15__gcompare_func);
#line 367 "menubar.vala"
	_tmp19_ = g_getenv ("LANG");
#line 367 "menubar.vala"
	_tmp20_ = g_getenv ("LANGUAGE");
#line 367 "menubar.vala"
	g_debug ("menubar.vala:367: LANG=%s LANGUAGE=%s", _tmp19_, _tmp20_);
#line 312 "menubar.vala"
	indicator_list = (_vala_array_free (indicator_list, indicator_list_length1, (GDestroyNotify) g_free), NULL);
#line 1920 "menubar.c"
}

static void
menu_bar_keyboard_toggled_cb (MenuBar* self,
                              GtkCheckMenuItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GError* _inner_error0_ = NULL;
#line 370 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 370 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 378 "menubar.vala"
	_tmp0_ = gtk_check_menu_item_get_active (item);
#line 378 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 378 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD, _tmp1_);
#line 380 "menubar.vala"
	_tmp2_ = self->priv->_keyboard_window;
#line 380 "menubar.vala"
	if (_tmp2_ == NULL) {
#line 1948 "menubar.c"
		gint id = 0;
		GtkSocket* keyboard_socket = NULL;
		GtkSocket* _tmp16_;
		GtkSocket* _tmp17_;
		GtkWindow* _tmp18_;
		GtkWindow* _tmp19_;
		GtkWindow* _tmp20_;
		GtkWindow* _tmp21_;
		GtkWindow* _tmp22_;
		GtkSocket* _tmp23_;
		GtkSocket* _tmp24_;
		GdkScreen* screen = NULL;
		GdkScreen* _tmp25_;
		GdkScreen* _tmp26_;
		gint monitor = 0;
		GdkScreen* _tmp27_;
		GdkWindow* _tmp28_;
		GdkRectangle geom = {0};
		GdkScreen* _tmp29_;
		GdkRectangle _tmp30_ = {0};
		GtkWindow* _tmp31_;
		GdkRectangle _tmp32_;
		GdkRectangle _tmp33_;
		GdkRectangle _tmp34_;
		GtkWindow* _tmp35_;
		GdkRectangle _tmp36_;
#line 382 "menubar.vala"
		id = 0;
#line 1977 "menubar.c"
		{
			gchar** argv = NULL;
			gint argv_length1 = 0;
			gint _argv_size_ = 0;
			gint onboard_stdout_fd = 0;
			gchar** _tmp3_ = NULL;
			gint _tmp4_ = 0;
			gchar** _tmp5_;
			gint _tmp5__length1;
			GPid _tmp6_ = 0;
			gint _tmp7_ = 0;
			FILE* f = NULL;
			FILE* _tmp8_;
			gchar* stdout_text = NULL;
			gchar* _tmp9_;
			gint stdout_text_length1;
			gint _stdout_text_size_;
			FILE* _tmp10_;
			gchar* _tmp11_;
			gint _tmp11__length1;
			const gchar* _tmp12_;
#line 389 "menubar.vala"
			g_shell_parse_argv ("onboard --xid", &_tmp4_, &_tmp3_, &_inner_error0_);
#line 389 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 389 "menubar.vala"
			argv = _tmp3_;
#line 389 "menubar.vala"
			argv_length1 = _tmp4_;
#line 389 "menubar.vala"
			_argv_size_ = argv_length1;
#line 389 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2013 "menubar.c"
				goto __catch0_g_error;
			}
#line 390 "menubar.vala"
			_tmp5_ = argv;
#line 390 "menubar.vala"
			_tmp5__length1 = argv_length1;
#line 390 "menubar.vala"
			g_spawn_async_with_pipes (NULL, _tmp5_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp6_, NULL, &_tmp7_, NULL, &_inner_error0_);
#line 390 "menubar.vala"
			self->priv->keyboard_pid = _tmp6_;
#line 390 "menubar.vala"
			onboard_stdout_fd = _tmp7_;
#line 390 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2030 "menubar.c"
				goto __catch0_g_error;
			}
#line 399 "menubar.vala"
			_tmp8_ = fdopen (onboard_stdout_fd, "r");
#line 399 "menubar.vala"
			f = _tmp8_;
#line 400 "menubar.vala"
			_tmp9_ = g_new0 (gchar, 1024);
#line 400 "menubar.vala"
			stdout_text = _tmp9_;
#line 400 "menubar.vala"
			stdout_text_length1 = 1024;
#line 400 "menubar.vala"
			_stdout_text_size_ = stdout_text_length1;
#line 401 "menubar.vala"
			_tmp10_ = f;
#line 401 "menubar.vala"
			_tmp11_ = stdout_text;
#line 401 "menubar.vala"
			_tmp11__length1 = stdout_text_length1;
#line 401 "menubar.vala"
			_tmp12_ = fgets (_tmp11_, (gint) _tmp11__length1, _tmp10_);
#line 401 "menubar.vala"
			if (_tmp12_ != NULL) {
#line 2055 "menubar.c"
				gchar* _tmp13_;
				gint _tmp13__length1;
#line 402 "menubar.vala"
				_tmp13_ = stdout_text;
#line 402 "menubar.vala"
				_tmp13__length1 = stdout_text_length1;
#line 402 "menubar.vala"
				id = atoi ((const gchar*) _tmp13_);
#line 2064 "menubar.c"
			}
#line 384 "menubar.vala"
			stdout_text = (g_free (stdout_text), NULL);
#line 384 "menubar.vala"
			_fclose0 (f);
#line 384 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2072 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 384 "menubar.vala"
			e = _inner_error0_;
#line 384 "menubar.vala"
			_inner_error0_ = NULL;
#line 407 "menubar.vala"
			_tmp14_ = e;
#line 407 "menubar.vala"
			_tmp15_ = _tmp14_->message;
#line 407 "menubar.vala"
			g_warning ("menubar.vala:407: Error setting up keyboard: %s", _tmp15_);
#line 408 "menubar.vala"
			_g_error_free0 (e);
#line 408 "menubar.vala"
			return;
#line 2094 "menubar.c"
		}
		__finally0:
#line 384 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 384 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 384 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 384 "menubar.vala"
			return;
#line 2105 "menubar.c"
		}
#line 411 "menubar.vala"
		_tmp16_ = (GtkSocket*) gtk_socket_new ();
#line 411 "menubar.vala"
		g_object_ref_sink (_tmp16_);
#line 411 "menubar.vala"
		keyboard_socket = _tmp16_;
#line 412 "menubar.vala"
		_tmp17_ = keyboard_socket;
#line 412 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp17_);
#line 413 "menubar.vala"
		_tmp18_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
#line 413 "menubar.vala"
		g_object_ref_sink (_tmp18_);
#line 413 "menubar.vala"
		_tmp19_ = _tmp18_;
#line 413 "menubar.vala"
		menu_bar_set_keyboard_window (self, _tmp19_);
#line 413 "menubar.vala"
		_g_object_unref0 (_tmp19_);
#line 414 "menubar.vala"
		_tmp20_ = self->priv->_keyboard_window;
#line 414 "menubar.vala"
		gtk_window_set_accept_focus (_tmp20_, FALSE);
#line 415 "menubar.vala"
		_tmp21_ = self->priv->_keyboard_window;
#line 415 "menubar.vala"
		gtk_window_set_focus_on_map (_tmp21_, FALSE);
#line 416 "menubar.vala"
		_tmp22_ = self->priv->_keyboard_window;
#line 416 "menubar.vala"
		_tmp23_ = keyboard_socket;
#line 416 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 417 "menubar.vala"
		_tmp24_ = keyboard_socket;
#line 417 "menubar.vala"
		gtk_socket_add_id (_tmp24_, (Window) id);
#line 420 "menubar.vala"
		_tmp25_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 420 "menubar.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 420 "menubar.vala"
		screen = _tmp26_;
#line 421 "menubar.vala"
		_tmp27_ = screen;
#line 421 "menubar.vala"
		_tmp28_ = gtk_widget_get_window ((GtkWidget*) self);
#line 421 "menubar.vala"
		monitor = gdk_screen_get_monitor_at_window (_tmp27_, _tmp28_);
#line 423 "menubar.vala"
		_tmp29_ = screen;
#line 423 "menubar.vala"
		gdk_screen_get_monitor_geometry (_tmp29_, monitor, &_tmp30_);
#line 423 "menubar.vala"
		geom = _tmp30_;
#line 424 "menubar.vala"
		_tmp31_ = self->priv->_keyboard_window;
#line 424 "menubar.vala"
		_tmp32_ = geom;
#line 424 "menubar.vala"
		_tmp33_ = geom;
#line 424 "menubar.vala"
		_tmp34_ = geom;
#line 424 "menubar.vala"
		gtk_window_move (_tmp31_, _tmp32_.x, (_tmp33_.y + _tmp34_.height) - 200);
#line 425 "menubar.vala"
		_tmp35_ = self->priv->_keyboard_window;
#line 425 "menubar.vala"
		_tmp36_ = geom;
#line 425 "menubar.vala"
		gtk_window_resize (_tmp35_, _tmp36_.width, 200);
#line 380 "menubar.vala"
		_g_object_unref0 (screen);
#line 380 "menubar.vala"
		_g_object_unref0 (keyboard_socket);
#line 2183 "menubar.c"
	}
#line 428 "menubar.vala"
	_tmp37_ = self->priv->_keyboard_window;
#line 428 "menubar.vala"
	_tmp38_ = gtk_check_menu_item_get_active (item);
#line 428 "menubar.vala"
	_tmp39_ = _tmp38_;
#line 428 "menubar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp37_, _tmp39_);
#line 2193 "menubar.c"
}

static void
menu_bar_high_contrast_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 431 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 431 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 433 "menubar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 433 "menubar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 433 "menubar.vala"
	settings = _tmp1_;
#line 434 "menubar.vala"
	_tmp2_ = gtk_check_menu_item_get_active (item);
#line 434 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 434 "menubar.vala"
	if (_tmp3_) {
#line 2224 "menubar.c"
		GtkSettings* _tmp4_;
#line 435 "menubar.vala"
		_tmp4_ = settings;
#line 435 "menubar.vala"
		g_object_set ((GObject*) _tmp4_, "gtk-theme-name", "HighContrastInverse", NULL);
#line 2230 "menubar.c"
	} else {
		GtkSettings* _tmp5_;
		const gchar* _tmp6_;
#line 437 "menubar.vala"
		_tmp5_ = settings;
#line 437 "menubar.vala"
		_tmp6_ = self->priv->default_theme_name;
#line 437 "menubar.vala"
		g_object_set ((GObject*) _tmp5_, "gtk-theme-name", _tmp6_, NULL);
#line 2240 "menubar.c"
	}
#line 438 "menubar.vala"
	_tmp7_ = gtk_check_menu_item_get_active (item);
#line 438 "menubar.vala"
	_tmp8_ = _tmp7_;
#line 438 "menubar.vala"
	menu_bar_set_high_contrast (self, _tmp8_);
#line 439 "menubar.vala"
	_tmp9_ = self->priv->_high_contrast;
#line 439 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_HIGH_CONTRAST, _tmp9_);
#line 431 "menubar.vala"
	_g_object_unref0 (settings);
#line 2254 "menubar.c"
}

static gboolean
____lambda14_ (MenuBar* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	AtkObject* _tmp2_;
	gboolean result;
#line 479 "menubar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 479 "menubar.vala"
	_tmp1_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 479 "menubar.vala"
	_tmp2_ = gtk_widget_get_accessible (_tmp1_);
#line 479 "menubar.vala"
	g_signal_emit_by_name (_tmp2_, "focus-event", TRUE, NULL);
#line 480 "menubar.vala"
	result = FALSE;
#line 480 "menubar.vala"
	return result;
#line 2276 "menubar.c"
}

static gboolean
_____lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda14_ ((MenuBar*) self);
#line 478 "menubar.vala"
	return result;
#line 2286 "menubar.c"
}

static void
menu_bar_screen_reader_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GError* _inner_error0_ = NULL;
#line 442 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 442 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 450 "menubar.vala"
	_tmp0_ = gtk_check_menu_item_get_active (item);
#line 450 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 450 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_SCREEN_READER, _tmp1_);
#line 453 "menubar.vala"
	_tmp2_ = gtk_check_menu_item_get_active (item);
#line 453 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 453 "menubar.vala"
	if (_tmp3_) {
#line 2314 "menubar.c"
		{
			gchar** argv = NULL;
			gint argv_length1 = 0;
			gint _argv_size_ = 0;
			gchar** _tmp4_ = NULL;
			gint _tmp5_ = 0;
			gchar** _tmp6_;
			gint _tmp6__length1;
			GPid _tmp7_ = 0;
			UnityGreeter* _tmp8_;
#line 458 "menubar.vala"
			g_shell_parse_argv ("orca --replace --no-setup --disable splash-window,", &_tmp5_, &_tmp4_, &_inner_error0_);
#line 458 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 458 "menubar.vala"
			argv = _tmp4_;
#line 458 "menubar.vala"
			argv_length1 = _tmp5_;
#line 458 "menubar.vala"
			_argv_size_ = argv_length1;
#line 458 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 458 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2339 "menubar.c"
				goto __catch0_g_error;
			}
#line 459 "menubar.vala"
			_tmp6_ = argv;
#line 459 "menubar.vala"
			_tmp6__length1 = argv_length1;
#line 459 "menubar.vala"
			g_spawn_async (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, &_inner_error0_);
#line 459 "menubar.vala"
			self->priv->reader_pid = _tmp7_;
#line 459 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 459 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2354 "menubar.c"
				goto __catch0_g_error;
			}
#line 477 "menubar.vala"
			_tmp8_ = unity_greeter_singleton;
#line 477 "menubar.vala"
			_tmp8_->orca_needs_kick = TRUE;
#line 478 "menubar.vala"
			g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _____lambda14__gsource_func, g_object_ref (self), g_object_unref);
#line 455 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2365 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 455 "menubar.vala"
			e = _inner_error0_;
#line 455 "menubar.vala"
			_inner_error0_ = NULL;
#line 485 "menubar.vala"
			_tmp9_ = e;
#line 485 "menubar.vala"
			_tmp10_ = _tmp9_->message;
#line 485 "menubar.vala"
			g_warning ("menubar.vala:485: Failed to run Orca: %s", _tmp10_);
#line 455 "menubar.vala"
			_g_error_free0 (e);
#line 2385 "menubar.c"
		}
		__finally0:
#line 455 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 455 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 455 "menubar.vala"
			return;
#line 2396 "menubar.c"
		}
	} else {
#line 489 "menubar.vala"
		menu_bar_close_pid (self, &self->priv->reader_pid);
#line 2401 "menubar.c"
	}
}

static guint
menu_bar_get_indicator_index (MenuBar* self,
                              IndicatorObject* object)
{
	guint index = 0U;
	GList* _tmp0_;
	guint result;
#line 492 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 492 "menubar.vala"
	g_return_val_if_fail (object != NULL, 0U);
#line 494 "menubar.vala"
	index = (guint) 0;
#line 496 "menubar.vala"
	_tmp0_ = self->priv->indicator_objects;
#line 2420 "menubar.c"
	{
		GList* io_collection = NULL;
		GList* io_it = NULL;
#line 496 "menubar.vala"
		io_collection = _tmp0_;
#line 496 "menubar.vala"
		for (io_it = io_collection; io_it != NULL; io_it = io_it->next) {
#line 2428 "menubar.c"
			IndicatorObject* _tmp1_;
			IndicatorObject* io = NULL;
#line 496 "menubar.vala"
			_tmp1_ = _g_object_ref0 ((IndicatorObject*) io_it->data);
#line 496 "menubar.vala"
			io = _tmp1_;
#line 2435 "menubar.c"
			{
				IndicatorObject* _tmp2_;
				guint _tmp3_;
#line 498 "menubar.vala"
				_tmp2_ = io;
#line 498 "menubar.vala"
				if (_tmp2_ == object) {
#line 499 "menubar.vala"
					result = index;
#line 499 "menubar.vala"
					_g_object_unref0 (io);
#line 499 "menubar.vala"
					return result;
#line 2449 "menubar.c"
				}
#line 500 "menubar.vala"
				_tmp3_ = index;
#line 500 "menubar.vala"
				index = _tmp3_ + 1;
#line 496 "menubar.vala"
				_g_object_unref0 (io);
#line 2457 "menubar.c"
			}
		}
	}
#line 503 "menubar.vala"
	result = index;
#line 503 "menubar.vala"
	return result;
#line 2465 "menubar.c"
}

static IndicatorObject*
menu_bar_get_indicator_object_from_entry (MenuBar* self,
                                          IndicatorObjectEntry* entry)
{
	GList* _tmp0_;
	IndicatorObject* result;
#line 506 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 506 "menubar.vala"
	g_return_val_if_fail (entry != NULL, NULL);
#line 508 "menubar.vala"
	_tmp0_ = self->priv->indicator_objects;
#line 2480 "menubar.c"
	{
		GList* io_collection = NULL;
		GList* io_it = NULL;
#line 508 "menubar.vala"
		io_collection = _tmp0_;
#line 508 "menubar.vala"
		for (io_it = io_collection; io_it != NULL; io_it = io_it->next) {
#line 2488 "menubar.c"
			IndicatorObject* _tmp1_;
			IndicatorObject* io = NULL;
#line 508 "menubar.vala"
			_tmp1_ = _g_object_ref0 ((IndicatorObject*) io_it->data);
#line 508 "menubar.vala"
			io = _tmp1_;
#line 2495 "menubar.c"
			{
				IndicatorObject* _tmp2_;
				GList* _tmp3_;
#line 510 "menubar.vala"
				_tmp2_ = io;
#line 510 "menubar.vala"
				_tmp3_ = indicator_object_get_entries (_tmp2_);
#line 2503 "menubar.c"
				{
					GList* e_collection = NULL;
					GList* e_it = NULL;
#line 510 "menubar.vala"
					e_collection = _tmp3_;
#line 510 "menubar.vala"
					for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
#line 2511 "menubar.c"
						IndicatorObjectEntry* e = NULL;
#line 510 "menubar.vala"
						e = (IndicatorObjectEntry*) e_it->data;
#line 2515 "menubar.c"
						{
							IndicatorObjectEntry* _tmp4_;
#line 512 "menubar.vala"
							_tmp4_ = e;
#line 512 "menubar.vala"
							if (_tmp4_ == entry) {
#line 513 "menubar.vala"
								result = io;
#line 513 "menubar.vala"
								(e_collection == NULL) ? NULL : (e_collection = (g_list_free (e_collection), NULL));
#line 513 "menubar.vala"
								return result;
#line 2528 "menubar.c"
							}
						}
					}
#line 510 "menubar.vala"
					(e_collection == NULL) ? NULL : (e_collection = (g_list_free (e_collection), NULL));
#line 2534 "menubar.c"
				}
#line 508 "menubar.vala"
				_g_object_unref0 (io);
#line 2538 "menubar.c"
			}
		}
	}
#line 517 "menubar.vala"
	result = NULL;
#line 517 "menubar.vala"
	return result;
#line 2546 "menubar.c"
}

static void
menu_bar_indicator_added_cb (MenuBar* self,
                             IndicatorObject* object,
                             IndicatorObjectEntry* entry)
{
	guint index = 0U;
	gint pos = 0;
	GList* _tmp0_;
	IndicatorMenuItem* menuitem = NULL;
	IndicatorMenuItem* _tmp9_;
#line 520 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 520 "menubar.vala"
	g_return_if_fail (object != NULL);
#line 520 "menubar.vala"
	g_return_if_fail (entry != NULL);
#line 522 "menubar.vala"
	index = menu_bar_get_indicator_index (self, object);
#line 523 "menubar.vala"
	pos = 0;
#line 524 "menubar.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 2571 "menubar.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 524 "menubar.vala"
		child_collection = _tmp0_;
#line 524 "menubar.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 2579 "menubar.c"
			GtkWidget* child = NULL;
#line 524 "menubar.vala"
			child = (GtkWidget*) child_it->data;
#line 2583 "menubar.c"
			{
				GtkWidget* _tmp1_;
				IndicatorMenuItem* menuitem = NULL;
				GtkWidget* _tmp2_;
				IndicatorMenuItem* _tmp3_;
				IndicatorObject* child_object = NULL;
				IndicatorMenuItem* _tmp4_;
				IndicatorObjectEntry* _tmp5_;
				IndicatorObject* _tmp6_;
				guint child_index = 0U;
				IndicatorObject* _tmp7_;
				gint _tmp8_;
#line 526 "menubar.vala"
				_tmp1_ = child;
#line 526 "menubar.vala"
				if (!IS_INDICATOR_MENU_ITEM (_tmp1_)) {
#line 527 "menubar.vala"
					break;
#line 2602 "menubar.c"
				}
#line 529 "menubar.vala"
				_tmp2_ = child;
#line 529 "menubar.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_INDICATOR_MENU_ITEM, IndicatorMenuItem));
#line 529 "menubar.vala"
				menuitem = _tmp3_;
#line 530 "menubar.vala"
				_tmp4_ = menuitem;
#line 530 "menubar.vala"
				_tmp5_ = _tmp4_->entry;
#line 530 "menubar.vala"
				_tmp6_ = menu_bar_get_indicator_object_from_entry (self, _tmp5_);
#line 530 "menubar.vala"
				child_object = _tmp6_;
#line 531 "menubar.vala"
				_tmp7_ = child_object;
#line 531 "menubar.vala"
				child_index = menu_bar_get_indicator_index (self, _tmp7_);
#line 532 "menubar.vala"
				if (child_index > index) {
#line 533 "menubar.vala"
					_g_object_unref0 (child_object);
#line 533 "menubar.vala"
					_g_object_unref0 (menuitem);
#line 533 "menubar.vala"
					break;
#line 2630 "menubar.c"
				}
#line 534 "menubar.vala"
				_tmp8_ = pos;
#line 534 "menubar.vala"
				pos = _tmp8_ + 1;
#line 524 "menubar.vala"
				_g_object_unref0 (child_object);
#line 524 "menubar.vala"
				_g_object_unref0 (menuitem);
#line 2640 "menubar.c"
			}
		}
#line 524 "menubar.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2645 "menubar.c"
	}
#line 537 "menubar.vala"
	g_debug ("menubar.vala:537: Adding indicator object %p at position %d", entry, pos);
#line 539 "menubar.vala"
	_tmp9_ = indicator_menu_item_new (entry);
#line 539 "menubar.vala"
	g_object_ref_sink (_tmp9_);
#line 539 "menubar.vala"
	menuitem = _tmp9_;
#line 540 "menubar.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) self, (GtkWidget*) menuitem, pos);
#line 520 "menubar.vala"
	_g_object_unref0 (menuitem);
#line 2659 "menubar.c"
}

static void
menu_bar_indicator_removed_cb (MenuBar* self,
                               IndicatorObject* object,
                               IndicatorObjectEntry* entry)
{
	GList* _tmp0_;
#line 543 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 543 "menubar.vala"
	g_return_if_fail (object != NULL);
#line 543 "menubar.vala"
	g_return_if_fail (entry != NULL);
#line 545 "menubar.vala"
	g_debug ("menubar.vala:545: Removing indicator object %p", entry);
#line 547 "menubar.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 2678 "menubar.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 547 "menubar.vala"
		child_collection = _tmp0_;
#line 547 "menubar.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 2686 "menubar.c"
			GtkWidget* child = NULL;
#line 547 "menubar.vala"
			child = (GtkWidget*) child_it->data;
#line 2690 "menubar.c"
			{
				IndicatorMenuItem* menuitem = NULL;
				GtkWidget* _tmp1_;
				IndicatorMenuItem* _tmp2_;
				IndicatorMenuItem* _tmp3_;
				IndicatorObjectEntry* _tmp4_;
#line 549 "menubar.vala"
				_tmp1_ = child;
#line 549 "menubar.vala"
				_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_INDICATOR_MENU_ITEM, IndicatorMenuItem));
#line 549 "menubar.vala"
				menuitem = _tmp2_;
#line 550 "menubar.vala"
				_tmp3_ = menuitem;
#line 550 "menubar.vala"
				_tmp4_ = _tmp3_->entry;
#line 550 "menubar.vala"
				if (_tmp4_ == entry) {
#line 2709 "menubar.c"
					GtkWidget* _tmp5_;
#line 552 "menubar.vala"
					_tmp5_ = child;
#line 552 "menubar.vala"
					gtk_container_remove ((GtkContainer*) self, _tmp5_);
#line 553 "menubar.vala"
					_g_object_unref0 (menuitem);
#line 553 "menubar.vala"
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 553 "menubar.vala"
					return;
#line 2721 "menubar.c"
				}
#line 547 "menubar.vala"
				_g_object_unref0 (menuitem);
#line 2725 "menubar.c"
			}
		}
#line 547 "menubar.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2730 "menubar.c"
	}
#line 557 "menubar.vala"
	g_warning ("menubar.vala:557: Indicator object %p not in menubar", entry);
#line 2734 "menubar.c"
}

Background*
menu_bar_get_background (MenuBar* self)
{
	Background* result;
	Background* _tmp0_;
#line 68 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "menubar.vala"
	_tmp0_ = self->priv->_background;
#line 68 "menubar.vala"
	result = _tmp0_;
#line 68 "menubar.vala"
	return result;
#line 2750 "menubar.c"
}

static void
menu_bar_set_background (MenuBar* self,
                         Background* value)
{
	Background* old_value;
#line 68 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 68 "menubar.vala"
	old_value = menu_bar_get_background (self);
#line 68 "menubar.vala"
	if (old_value != value) {
#line 2764 "menubar.c"
		Background* _tmp0_;
#line 68 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 68 "menubar.vala"
		_g_object_unref0 (self->priv->_background);
#line 68 "menubar.vala"
		self->priv->_background = _tmp0_;
#line 68 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_BACKGROUND_PROPERTY]);
#line 2774 "menubar.c"
	}
}

gboolean
menu_bar_get_high_contrast (MenuBar* self)
{
	gboolean result;
#line 69 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "menubar.vala"
	result = self->priv->_high_contrast;
#line 69 "menubar.vala"
	return result;
#line 2788 "menubar.c"
}

static void
menu_bar_set_high_contrast (MenuBar* self,
                            gboolean value)
{
	gboolean old_value;
#line 69 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 69 "menubar.vala"
	old_value = menu_bar_get_high_contrast (self);
#line 69 "menubar.vala"
	if (old_value != value) {
#line 69 "menubar.vala"
		self->priv->_high_contrast = value;
#line 69 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_HIGH_CONTRAST_PROPERTY]);
#line 2806 "menubar.c"
	}
}

GtkWindow*
menu_bar_get_keyboard_window (MenuBar* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 70 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "menubar.vala"
	_tmp0_ = self->priv->_keyboard_window;
#line 70 "menubar.vala"
	result = _tmp0_;
#line 70 "menubar.vala"
	return result;
#line 2823 "menubar.c"
}

static void
menu_bar_set_keyboard_window (MenuBar* self,
                              GtkWindow* value)
{
	GtkWindow* old_value;
#line 70 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 70 "menubar.vala"
	old_value = menu_bar_get_keyboard_window (self);
#line 70 "menubar.vala"
	if (old_value != value) {
#line 2837 "menubar.c"
		GtkWindow* _tmp0_;
#line 70 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 70 "menubar.vala"
		_g_object_unref0 (self->priv->_keyboard_window);
#line 70 "menubar.vala"
		self->priv->_keyboard_window = _tmp0_;
#line 70 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_KEYBOARD_WINDOW_PROPERTY]);
#line 2847 "menubar.c"
	}
}

GtkAccelGroup*
menu_bar_get_accel_group (MenuBar* self)
{
	GtkAccelGroup* result;
	GtkAccelGroup* _tmp0_;
#line 71 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "menubar.vala"
	_tmp0_ = self->priv->_accel_group;
#line 71 "menubar.vala"
	result = _tmp0_;
#line 71 "menubar.vala"
	return result;
#line 2864 "menubar.c"
}

static void
menu_bar_set_accel_group (MenuBar* self,
                          GtkAccelGroup* value)
{
	GtkAccelGroup* old_value;
#line 71 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 71 "menubar.vala"
	old_value = menu_bar_get_accel_group (self);
#line 71 "menubar.vala"
	if (old_value != value) {
#line 2878 "menubar.c"
		GtkAccelGroup* _tmp0_;
#line 71 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 71 "menubar.vala"
		_g_object_unref0 (self->priv->_accel_group);
#line 71 "menubar.vala"
		self->priv->_accel_group = _tmp0_;
#line 71 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_ACCEL_GROUP_PROPERTY]);
#line 2888 "menubar.c"
	}
}

static void
_menu_bar_cleanup_unity_greeter_starting_session (UnityGreeter* _sender,
                                                  gpointer self)
{
#line 156 "menubar.vala"
	menu_bar_cleanup ((MenuBar*) self);
#line 2898 "menubar.c"
}

static GObject *
menu_bar_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MenuBar * self;
	GtkSettings* _tmp0_;
	gchar* _tmp1_ = NULL;
	UnityGreeter* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 119 "menubar.vala"
	parent_class = G_OBJECT_CLASS (menu_bar_parent_class);
#line 119 "menubar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 119 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
#line 121 "menubar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 121 "menubar.vala"
	g_object_get ((GObject*) _tmp0_, "gtk-theme-name", &_tmp1_, NULL);
#line 121 "menubar.vala"
	_g_free0 (self->priv->default_theme_name);
#line 121 "menubar.vala"
	self->priv->default_theme_name = _tmp1_;
#line 123 "menubar.vala"
	gtk_menu_bar_set_pack_direction ((GtkMenuBar*) self, GTK_PACK_DIRECTION_RTL);
#line 125 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_HOSTNAME)) {
#line 2931 "menubar.c"
		GtkLabel* label = NULL;
		struct utsname _tmp2_ = {0};
		const gchar* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		GtkMenuItem* hostname_item = NULL;
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkLabel* _tmp8_;
		GtkMenuItem* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenuItem* _tmp11_;
		GtkMenuItem* _tmp12_;
		GtkLabel* _tmp13_;
		GdkRGBA fg = {0};
		GtkLabel* _tmp14_;
		GtkStyleContext* _tmp15_;
		GdkRGBA _tmp16_ = {0};
		GtkLabel* _tmp17_;
		GdkRGBA _tmp18_;
#line 127 "menubar.vala"
		uname (&_tmp2_);
#line 127 "menubar.vala"
		_tmp3_ = _tmp2_.nodename;
#line 127 "menubar.vala"
		_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
#line 127 "menubar.vala"
		g_object_ref_sink (_tmp4_);
#line 127 "menubar.vala"
		label = _tmp4_;
#line 128 "menubar.vala"
		_tmp5_ = label;
#line 128 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp5_);
#line 129 "menubar.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 129 "menubar.vala"
		g_object_ref_sink (_tmp6_);
#line 129 "menubar.vala"
		hostname_item = _tmp6_;
#line 130 "menubar.vala"
		_tmp7_ = hostname_item;
#line 130 "menubar.vala"
		_tmp8_ = label;
#line 130 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 131 "menubar.vala"
		_tmp9_ = hostname_item;
#line 131 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 132 "menubar.vala"
		_tmp10_ = hostname_item;
#line 132 "menubar.vala"
		gtk_menu_item_set_right_justified (_tmp10_, TRUE);
#line 133 "menubar.vala"
		_tmp11_ = hostname_item;
#line 133 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp11_);
#line 134 "menubar.vala"
		_tmp12_ = hostname_item;
#line 134 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp12_);
#line 137 "menubar.vala"
		_tmp13_ = label;
#line 137 "menubar.vala"
		gtk_widget_ensure_style ((GtkWidget*) _tmp13_);
#line 138 "menubar.vala"
		_tmp14_ = label;
#line 138 "menubar.vala"
		_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 138 "menubar.vala"
		gtk_style_context_get_color (_tmp15_, GTK_STATE_FLAG_NORMAL, &_tmp16_);
#line 138 "menubar.vala"
		fg = _tmp16_;
#line 139 "menubar.vala"
		_tmp17_ = label;
#line 139 "menubar.vala"
		_tmp18_ = fg;
#line 139 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp17_, GTK_STATE_FLAG_INSENSITIVE, &_tmp18_);
#line 125 "menubar.vala"
		_g_object_unref0 (hostname_item);
#line 125 "menubar.vala"
		_g_object_unref0 (label);
#line 3016 "menubar.c"
	}
	{
		GtkCssProvider* style = NULL;
		GtkCssProvider* _tmp19_;
		GtkCssProvider* _tmp20_;
		GtkStyleContext* _tmp21_;
		GtkCssProvider* _tmp22_;
#line 145 "menubar.vala"
		_tmp19_ = gtk_css_provider_new ();
#line 145 "menubar.vala"
		style = _tmp19_;
#line 146 "menubar.vala"
		_tmp20_ = style;
#line 146 "menubar.vala"
		gtk_css_provider_load_from_data (_tmp20_, "* {-GtkWidget-window-dragging: false;}", (gssize) -1, &_inner_error0_);
#line 146 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "menubar.vala"
			_g_object_unref0 (style);
#line 3036 "menubar.c"
			goto __catch0_g_error;
		}
#line 147 "menubar.vala"
		_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 147 "menubar.vala"
		_tmp22_ = style;
#line 147 "menubar.vala"
		gtk_style_context_add_provider (_tmp21_, (GtkStyleProvider*) _tmp22_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 143 "menubar.vala"
		_g_object_unref0 (style);
#line 3047 "menubar.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 143 "menubar.vala"
		e = _inner_error0_;
#line 143 "menubar.vala"
		_inner_error0_ = NULL;
#line 151 "menubar.vala"
		_tmp23_ = e;
#line 151 "menubar.vala"
		_tmp24_ = _tmp23_->message;
#line 151 "menubar.vala"
		g_debug ("menubar.vala:151: Internal error loading menubar style: %s", _tmp24_);
#line 143 "menubar.vala"
		_g_error_free0 (e);
#line 3067 "menubar.c"
	}
	__finally0:
#line 143 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 3076 "menubar.c"
	}
#line 154 "menubar.vala"
	menu_bar_setup_indicators (self);
#line 156 "menubar.vala"
	_tmp25_ = unity_greeter_singleton;
#line 156 "menubar.vala"
	g_signal_connect_object (_tmp25_, "starting-session", (GCallback) _menu_bar_cleanup_unity_greeter_starting_session, self, 0);
#line 119 "menubar.vala"
	return obj;
#line 3086 "menubar.c"
}

static void
menu_bar_class_init (MenuBarClass * klass,
                     gpointer klass_data)
{
#line 66 "menubar.vala"
	menu_bar_parent_class = g_type_class_peek_parent (klass);
#line 66 "menubar.vala"
	g_type_class_adjust_private_offset (klass, &MenuBar_private_offset);
#line 66 "menubar.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) menu_bar_real_draw;
#line 66 "menubar.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) menu_bar_real_get_preferred_height;
#line 66 "menubar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_bar_get_property;
#line 66 "menubar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_bar_set_property;
#line 66 "menubar.vala"
	G_OBJECT_CLASS (klass)->constructor = menu_bar_constructor;
#line 66 "menubar.vala"
	G_OBJECT_CLASS (klass)->finalize = menu_bar_finalize;
#line 66 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_BACKGROUND_PROPERTY, menu_bar_properties[MENU_BAR_BACKGROUND_PROPERTY] = g_param_spec_object ("background", "background", "background", TYPE_BACKGROUND, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 66 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_HIGH_CONTRAST_PROPERTY, menu_bar_properties[MENU_BAR_HIGH_CONTRAST_PROPERTY] = g_param_spec_boolean ("high-contrast", "high-contrast", "high-contrast", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 66 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_KEYBOARD_WINDOW_PROPERTY, menu_bar_properties[MENU_BAR_KEYBOARD_WINDOW_PROPERTY] = g_param_spec_object ("keyboard-window", "keyboard-window", "keyboard-window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 66 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_ACCEL_GROUP_PROPERTY, menu_bar_properties[MENU_BAR_ACCEL_GROUP_PROPERTY] = g_param_spec_object ("accel-group", "accel-group", "accel-group", gtk_accel_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3117 "menubar.c"
}

static void
menu_bar_instance_init (MenuBar * self,
                        gpointer klass)
{
#line 66 "menubar.vala"
	self->priv = menu_bar_get_instance_private (self);
#line 68 "menubar.vala"
	self->priv->_background = NULL;
#line 69 "menubar.vala"
	self->priv->_high_contrast = FALSE;
#line 70 "menubar.vala"
	self->priv->_keyboard_window = NULL;
#line 115 "menubar.vala"
	self->priv->keyboard_pid = (GPid) 0;
#line 116 "menubar.vala"
	self->priv->reader_pid = (GPid) 0;
#line 3136 "menubar.c"
}

static void
menu_bar_finalize (GObject * obj)
{
	MenuBar * self;
#line 66 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
#line 68 "menubar.vala"
	_g_object_unref0 (self->priv->_background);
#line 70 "menubar.vala"
	_g_object_unref0 (self->priv->_keyboard_window);
#line 71 "menubar.vala"
	_g_object_unref0 (self->priv->_accel_group);
#line 112 "menubar.vala"
	_g_free0 (self->priv->default_theme_name);
#line 113 "menubar.vala"
	(self->priv->indicator_objects == NULL) ? NULL : (self->priv->indicator_objects = (_g_list_free__g_object_unref0_ (self->priv->indicator_objects), NULL));
#line 114 "menubar.vala"
	_g_object_unref0 (self->priv->high_contrast_item);
#line 117 "menubar.vala"
	_g_object_unref0 (self->priv->onscreen_keyboard_item);
#line 66 "menubar.vala"
	G_OBJECT_CLASS (menu_bar_parent_class)->finalize (obj);
#line 3161 "menubar.c"
}

static GType
menu_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MenuBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenuBar), 0, (GInstanceInitFunc) menu_bar_instance_init, NULL };
	GType menu_bar_type_id;
	menu_bar_type_id = g_type_register_static (gtk_menu_bar_get_type (), "MenuBar", &g_define_type_info, 0);
	MenuBar_private_offset = g_type_add_instance_private (menu_bar_type_id, sizeof (MenuBarPrivate));
	return menu_bar_type_id;
}

GType
menu_bar_get_type (void)
{
	static volatile gsize menu_bar_type_id__once = 0;
	if (g_once_init_enter (&menu_bar_type_id__once)) {
		GType menu_bar_type_id;
		menu_bar_type_id = menu_bar_get_type_once ();
		g_once_init_leave (&menu_bar_type_id__once, menu_bar_type_id);
	}
	return menu_bar_type_id__once;
}

static void
_vala_menu_bar_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
#line 66 "menubar.vala"
	switch (property_id) {
#line 66 "menubar.vala"
		case MENU_BAR_BACKGROUND_PROPERTY:
#line 66 "menubar.vala"
		g_value_set_object (value, menu_bar_get_background (self));
#line 66 "menubar.vala"
		break;
#line 66 "menubar.vala"
		case MENU_BAR_HIGH_CONTRAST_PROPERTY:
#line 66 "menubar.vala"
		g_value_set_boolean (value, menu_bar_get_high_contrast (self));
#line 66 "menubar.vala"
		break;
#line 66 "menubar.vala"
		case MENU_BAR_KEYBOARD_WINDOW_PROPERTY:
#line 66 "menubar.vala"
		g_value_set_object (value, menu_bar_get_keyboard_window (self));
#line 66 "menubar.vala"
		break;
#line 66 "menubar.vala"
		case MENU_BAR_ACCEL_GROUP_PROPERTY:
#line 66 "menubar.vala"
		g_value_set_object (value, menu_bar_get_accel_group (self));
#line 66 "menubar.vala"
		break;
#line 3220 "menubar.c"
		default:
#line 66 "menubar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 66 "menubar.vala"
		break;
#line 3226 "menubar.c"
	}
}

static void
_vala_menu_bar_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
#line 66 "menubar.vala"
	switch (property_id) {
#line 66 "menubar.vala"
		case MENU_BAR_BACKGROUND_PROPERTY:
#line 66 "menubar.vala"
		menu_bar_set_background (self, g_value_get_object (value));
#line 66 "menubar.vala"
		break;
#line 66 "menubar.vala"
		case MENU_BAR_HIGH_CONTRAST_PROPERTY:
#line 66 "menubar.vala"
		menu_bar_set_high_contrast (self, g_value_get_boolean (value));
#line 66 "menubar.vala"
		break;
#line 66 "menubar.vala"
		case MENU_BAR_KEYBOARD_WINDOW_PROPERTY:
#line 66 "menubar.vala"
		menu_bar_set_keyboard_window (self, g_value_get_object (value));
#line 66 "menubar.vala"
		break;
#line 66 "menubar.vala"
		case MENU_BAR_ACCEL_GROUP_PROPERTY:
#line 66 "menubar.vala"
		menu_bar_set_accel_group (self, g_value_get_object (value));
#line 66 "menubar.vala"
		break;
#line 3264 "menubar.c"
		default:
#line 66 "menubar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 66 "menubar.vala"
		break;
#line 3270 "menubar.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

